#!/usr/bin/perl
# this is a variable which points to the location of the user/password file
# on the current system. This would definitely need to be modified to fit
# any other systems.
$userfile = 'users.file';
#Includes cgi-lib file; if cgi-lib doesn't exist, returns malformed
#header error
do "cgi-lib.pl" || die "Fatal Error: Can't load cgi library";
#calls the subroutine in the cgi-lib.pl library
#to read in the variables from the form and set them up
#as key=value pairs in the array @in
&ReadParse;
#Gather the ID & Password into simple string variables
$id = $in{'id'};
$password = $in{'password'};
# Make sure both the ID and Password were entered...
$test = $id && $password;
if (length($test) < 1) {
  #Refuses to continue if there is no name or password
  print "Content-type: text/html\n\n";
  print "<HTML>";
  print "<HEAD><TITLE>Invalid Registration</TITLE>";
  print "</HEAD><BODY>";
  print "<H1>Invalid Registration</H1>";
  print "<P>";
  print "You have either not entered a name or password.\n";
  print "<P>";
  print "<H2><I>--School of the Internet</I></H2>";
  print "<HR>";
  print "<H3>Back to the <A HREF=\"/index.html\">";
  print "Front Page</A></H3>";
  print "<H3>Back to the <A HREF=\"/register.html\">";
  print "Registration Form</A></H3>";
  print "</BODY></HTML>";
  #quit the script - not enough information was present to
  #process the registration.
  exit;
}
# I'm assuming that there is a simple file that consists of
# ID:Password entries and that it's not encrypted in any way.
#
# This would normally be unlikely, and the following code could
# of course be modified to include encryption with the "crypt" command
# in PERL.
# get the user's entry from the password file
# In using the "look" command, I'm assuming that the password file
# is sorted by ID (which could be done with a 'sort -t: -o users.file'
# command from the UNIX prompt)
$_ = `look -f $id $userfile`;
# check to make sure we found an entry in the user file
# by checking the length of the $_ variable. If it's less
# than 1, we didn't find anything.
if (length($_) < 1) {
  #Refuses to continue if the password doesn't match up
  print "Content-type: text/html\n\n";
  print "<HTML>";
  print "<HEAD><TITLE>Invalid Registration</TITLE>";
  print "</HEAD><BODY>";
  print "<H1>Invalid Registration</H1>";
  print "<P>\n";
  print "Your entry isn't listed in our user file.\n";
  print "<P>";
  print "<H2><I>--School of the Internet</I></H2>";
  print "<HR>";
  print "<H3>Back to the <A HREF=\"/index.html\">";
  print "Front Page</A></H3>";
  print "<H3>Back to the <A HREF=\"/register.html\">";
  print "Registration Form</A></H3>";
  print "</BODY></HTML>";
  #quit the script - An invalid password or ID was entered
  exit;
}
#split off the password from the rest of the data
@user_data = split(/:/);
#remove the linefeed at the end of the password
chop(@user_data[1]);
#check the password entered against entry in password file
unless ($password eq @user_data[1]) {
  #Refuses to continue if the password doesn't match up
  print "Content-type: text/html\n\n";
  print "<HTML>";
  print "<HEAD><TITLE>Invalid Registration</TITLE>";
  print "</HEAD><BODY>";
  print "<H1>Invalid Registration</H1>";
  print "<P>\n";
  print "You have entered an invalid name or password.\n";
  print "<P>";
  print "<H2><I>--School of the Internet</I></H2>";
  print "<HR>";
  print "<H3>Back to the <A HREF=\"/index.html\">";
  print "Front Page</A></H3>";
  print "<H3>Back to the <A HREF=\"/register.html\">";
  print "Registration Form</A></H3>";
  print "</BODY></HTML>";
  #quit the script - An invalid password or ID was entered
  exit;
} else {
#password matches the entry in the file, go ahead and do
#something with this verification.
  print "Content-type: text/html\n\n";
  print "<HTML>";
  print "<HEAD><TITLE>Registration Confirmation</TITLE>";
  print "</HEAD><BODY>";
  print "<H1>Registration Confirmation</H1>\n";
  print "<H2>You've registered for the following classes:</H2>\n";
  print "<PRE>\n";
  #break down the classes into an array
  @classes = split(/\\0/,$in{'classes'});
  #print out the array of classes
  for each (@classes) {
    print "     ";
    print;
    print "\n";
  }
  print "</PRE>";
  # Note:
  # We could do similar pattern matching here to get class names
  # for the courses listed, or add the information into a simple
  # database by writing it to a file. A more complex program could
  # also read that database and produce a document from it, allowing
  # students to update their files automatically (with the proper
  # password...)
  # Go through the list of checkbox'd materials that have been
  # requested...
  print "<H2>You've requested the following materials:</H2>\n";
  print "<UL>\n";
  if ($in{'ref'} eq "ref") {
    print "<LI> HTML Elements Reference\n";
  }
  if ($in{'biblio'} eq "biblio") {
    print "<LI> WWW Bibliography\n";
  }
  if ($in{'cdrom'} eq "cdrom") {
    print "<LI> What's on the CD-ROM\n";
  }
  if ($in{'html2'} eq "html2") {
    print "<LI> HTML Level 2 Definition\n";
  }
  if ($in{'html3'} eq "html3") {
    print "<LI> HTML Level 3 Definition\n";
  }
  print "</UL>";
  print "<H2><I>--School of the Internet</I></H2>";
  print "<HR>";
  print "<H3>Back to the <A HREF=\"/index.html\">";
  print "Front Page</A></H3>";
  print "</BODY></HTML>";
}
